#include "W25X40CL.h"

u8 FLASH_CheckID(void)					// ȡID
{
	u8 id;
	CS = 0;
	SPI_WriteByte(0xAB);				// дȡid
	SPI_WriteByte(0x00);				// д
	SPI_WriteByte(0x00);				// д
	SPI_WriteByte(0x00);				// д
	
	id = SPI_ReadByte();
	CS = 1;
	return id;
}	


u8 FLASH_CheckBusy(void)				// ȡ״̬
{
	u8 state;
	CS = 0;
	SPI_WriteByte(0x05);				// дȡ״̬
	state = SPI_ReadByte();
	CS = 1;
	return state;
}


void FLASH_WriteEnable(void)			// дʹ
{
	while(FLASH_CheckBusy()>0);
	CS = 0;
	SPI_WriteByte(0x06);				// дʹ
	CS = 1;
}

void FLASH_Erase(u32 addr)				// 
{
	while(FLASH_CheckBusy()>0);
	FLASH_WriteEnable();
	CS = 0;
	SPI_WriteByte(0x20);				// дʹ
	
	SPI_WriteByte((u8)(addr>>16));		// дַλ
	SPI_WriteByte((u8)(addr>>8));		// дַ
	SPI_WriteByte((u8)(addr>>0));		// дַλ
	CS = 1;
}

void FLASH_Read(u32 addr, u8 *buffr, u16 length)				// ȡ
{
	u16 i=0;
	while(FLASH_CheckBusy()>0);
	
	CS = 0;
	SPI_WriteByte(0x03);				// дȡ
	
	SPI_WriteByte((u8)(addr>>16));		// дַλ
	SPI_WriteByte((u8)(addr>>8));		// дַ
	SPI_WriteByte((u8)(addr>>0));		// дַλ
	
	do
	{
		buffr[i] = SPI_ReadByte();
		i++;
	}while(length--);
	CS = 1;
}


void FLASH_Write(u32 addr, u8 *buffr, u16 length)				// д
{
	u16 i=0;
	while(FLASH_CheckBusy()>0);
	FLASH_WriteEnable();
	CS = 0;
	SPI_WriteByte(0x02);				// д
	
	SPI_WriteByte((u8)(addr>>16));		// дַλ
	SPI_WriteByte((u8)(addr>>8));		// дַ
	SPI_WriteByte((u8)(addr>>0));		// дַλ
	
	do
	{
		SPI_WriteByte(buffr[i]);
		i++;
		if(addr & 0xFF == 0)
			break;
	}while(length--);
	CS = 1;
}
